/* Copyright (c) 2000-2003, jMock.org. See bundled LICENSE.txt */
package org.jmock.matcher;

import org.jmock.Constraint;
import org.jmock.dynamic.Invocation;

import java.util.List;

public class ArgumentsMatcher
        extends StatelessInvocationMatcher {
    private Constraint[] constraints;

    public ArgumentsMatcher(Constraint[] constraints) {
        ArgumentsMatcher.this.constraints = constraints;
    }

    public boolean matches(Invocation invocation) {
        return constraints.length == invocation.getParameterValues().size()
                && matchesValues(invocation.getParameterValues());
    }

    private boolean matchesValues(List list) {
        for (int i = 0; i < constraints.length; ++i) {
            if (!constraints[i].eval(list.get(i))) {
                return false;
            }
        }
        return true;
    }

    public Constraint[] getConstraints() {
        return constraints;
    }

    public String toString() {
        StringBuffer result = new StringBuffer();
        result.append("ArgumentMatcher: ");
        for (int i = 0; i < constraints.length; ++i) {
            result.append(constraints[i]).append(", ");
        }
        return result.toString();
    }

    public boolean equals(Object other) {
        return other != null && toString().equals(other.toString());
    }
}